--- q931.c.orig	2004-02-16 15:20:29.000000000 +0000
+++ q931.c	2004-02-16 15:41:49.000000000 +0000
@@ -2140,7 +2140,38 @@
 		pri->ev.ring.channel = c->channelno;
 		pri->ev.ring.callingpres = c->callerpres;
 		pri->ev.ring.callingplan = c->callerplan;
-		strncpy(pri->ev.ring.callingnum, c->callernum, sizeof(pri->ev.ring.callingnum) - 1);
+		if (pri->ev.ring.callingpres == PRES_NUMBER_NOT_AVAILABLE)
+		{
+		  strncpy(pri->ev.ring.callingnum, "UNAVAILABLE", sizeof(pri->ev.ring.callingnum) -1);
+		}
+		else if (
+			 (pri->ev.ring.callingpres == PRES_PROHIB_USER_NUMBER_NOT_SCREENED) ||
+			 (pri->ev.ring.callingpres == PRES_PROHIB_USER_NUMBER_PASSED_SCREEN) ||
+			 (pri->ev.ring.callingpres == PRES_PROHIB_USER_NUMBER_FAILED_SCREEN) ||
+			 (pri->ev.ring.callingpres == PRES_PROHIB_NETWORK_NUMBER)
+			)
+		{
+		  strncpy(pri->ev.ring.callingnum, "WITHHELD", sizeof(pri->ev.ring.callingnum) -1);
+		}
+		else if (
+			 (pri->ev.ring.callingpres == PRES_ALLOWED_USER_NUMBER_NOT_SCREENED) ||
+			 (pri->ev.ring.callingpres == PRES_ALLOWED_USER_NUMBER_PASSED_SCREEN) ||
+			 (pri->ev.ring.callingpres == PRES_ALLOWED_USER_NUMBER_FAILED_SCREEN) ||
+			 (pri->ev.ring.callingpres == PRES_ALLOWED_NETWORK_NUMBER)
+			)
+		{
+		  pri->ev.ring.callingnum[0] = 0;
+		  if (((pri->ev.ring.callingplan >> 4) & 0xF) ==  PRI_TON_INTERNATIONAL)
+		  {
+		    strncat(pri->ev.ring.callingnum, "00", sizeof(pri->ev.ring.callingnum) -1);
+		  }
+		  else if (((pri->ev.ring.callingplan >> 4) & 0xF) ==  PRI_TON_NATIONAL)
+		  {
+		    strncat(pri->ev.ring.callingnum, "0", sizeof(pri->ev.ring.callingnum) -1);
+		  }
+		  strncat(pri->ev.ring.callingnum, c->callernum, sizeof(pri->ev.ring.callingnum) - 1);
+		}
+
 		strncpy(pri->ev.ring.callingname, c->callername, sizeof(pri->ev.ring.callingname) - 1);
 		pri->ev.ring.calledplan = c->calledplan;
 		strncpy(pri->ev.ring.callednum, c->callednum, sizeof(pri->ev.ring.callednum) - 1);
